#ifndef _GAMMA_H_
#define _GAMMA_H_


#include <cmath>
#include <complex>
using namespace std;

#define PI                3.14159265358979324
#define sqrt2Pi           2.50662827463100050       // = sqrt(2*Pi)

typedef std::complex<double> cplx;

#define ZERO              cplx(0.0, 0.0)
#define ONE               cplx(1.0, 0.0)
#define theI              cplx(0.0, 1.0)

#define RE(z)     ((double)(std::real((cplx)z)))
#define IM(z)     ((double)(std::imag((cplx)z)))
#define ABS(z)    ((double)(std::abs((cplx)z)))
#define SIN(z)    ((cplx)(std::sin((cplx)z)))
#define EXP(z)    ((cplx)(std::exp((cplx)z)))
#define LOG(z)    ((cplx)(std::log((cplx)z)))
#define POW(z,a)  ((cplx)(std::pow((cplx)z,(cplx)a)))

// numTools
int roundToInteger (double x);
int isOdd (int m);
int isEven (int m);
cplx rSIN (cplx mu);

cplx gamma(cplx Z);

#endif // _GAMMA_H_
