#include "gamma.h"

// round to nearest integer
int roundToInteger (double x)
{
  if (0.0 < x)
    return (int)floor(x + 0.5);
  return (int)ceil(x - 0.5);
}

int isEven (int m)
{
  if (abs(m) % 2 == 0)
    return (1);
  else
    return (0);
}

int isOdd (int m)
{
  if (abs(m) % 2 == 0)
    return (0);
  else
    return (1);
}

cplx rSIN (cplx z)  // = PI / sin( PI * z)
{
  cplx z_red;
  double x,y, x_red, t;
  int m;
  cplx result;

  x = RE(z); y = IM(z);

  if ( x == 0.0 ) // sin(y*I) = sinh(y)*I, Pi/sin(Pi*y*I) = -I*Pi/sinh(Pi*y)
  {
    t = PI * y;
    result = - PI / sinh(PI * y);
    result = result * theI;
    return (result); // purely imaginary
  }

  // range reduction
  m = roundToInteger(x);

  x_red = (x - (double)m); // x = m + x_red, |x_red| <= 0.5
  z_red = x_red + y *theI;

  result = PI / SIN(PI * z_red);
  if ( isOdd(m) == 1 ) 
    result = - result;
  
  if (y == 0.0 )  // purely real
    result = real(result) + 0.0*theI;
  return (result);
}
